package com.sun.xml.internal.ws.policy.spi;

import com.sun.xml.internal.ws.policy.PolicyAssertion;

public interface PolicyAssertionValidator
{
    public abstract PolicyAssertionValidator.Fitness validateClientSide(PolicyAssertion p0);
    
    public abstract PolicyAssertionValidator.Fitness validateServerSide(PolicyAssertion p0);
    
    public abstract String[] declareSupportedDomains();
    
    public enum Fitness
    {
        UNKNOWN, 
        INVALID, 
        UNSUPPORTED, 
        SUPPORTED;
        
        public PolicyAssertionValidator.Fitness combine(PolicyAssertionValidator.Fitness other) {
            if (this.compareTo(other) < 0) {
                return other;
            }
            return this;
        }
    }
}
